Debian Bug report logs - #551638
dselect: track seen packages in a new frontend-unified state file

version graph

Package: dselect; Maintainer for dselect is Dpkg Developers <debian-dpkg@lists.debian.org>; Source for dselect is src:dpkg.

Reported by: Petr Vandrovec <vandrove@vc.cvut.cz>

Date: Sun, 6 Sep 2009 17:39:03 UTC

Severity: important

Found in version dpkg/1.15.4

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#545366; Package dselect. (Sun, 06 Sep 2009 17:39:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Petr Vandrovec <vandrove@vc.cvut.cz>:
New Bug report received and forwarded. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sun, 06 Sep 2009 17:39:11 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Petr Vandrovec <vandrove@vc.cvut.cz>
To: submit@bugs.debian.org
Subject: dselect 1.15.4 does not distinguish between new and old packages
Date: Sun, 06 Sep 2009 19:35:07 +0200
Package: dselect
Version: 1.15.4

Since today's update run dselect is completely confused and does not 
remember which packages are new and which are old - it lists all 
available and not installed packages as new, again and again.  And not 
only that, it also marks some of them for installation although I do not 
want them (and some are not installable at all - for some reason it 
wants to install libsasl2 which is not installable together with 
libsasl2-2).  I see that it updates available & status, they seem to 
contain valid data, but on load it somehow ignores them.

Besides that it creates some strange /var/lib/dpkg/updates/tmp.i which 
is full of lines saying '##padding', but other than that I do not see 
what can be wrong, and unfortunately diff between 1.15.3.1 and 1.15.4 is 
quite huge.

Thanks, Petr





Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#545366; Package dselect. (Mon, 07 Sep 2009 06:09:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Romain Bossart <romain.bossart@free.fr>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Mon, 07 Sep 2009 06:09:05 GMT) Full text and rfc822 format available.

Message #10 received at 545366@bugs.debian.org (full text, mbox):

From: Romain Bossart <romain.bossart@free.fr>
To: Debian Bug Tracking System <545366@bugs.debian.org>
Subject: dselect: same here
Date: Mon, 07 Sep 2009 07:57:40 +0200
Package: dselect
Version: 1.15.4
Severity: normal

Same problem here.
I had to use aptitude to see new packages.

Regards,
Romain


-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.30.1 (SMP w/4 CPU cores; PREEMPT)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages dselect depends on:
ii  dpkg                      1.15.4         Debian package management system
ii  libc6                     2.9-26         GNU C Library: Shared libraries
ii  libgcc1                   1:4.4.1-3      GCC support library
ii  libncursesw5              5.7+20090803-2 shared libraries for terminal hand
ii  libstdc++6                4.4.1-3        The GNU Standard C++ Library v3

dselect recommends no packages.

dselect suggests no packages.

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#545366; Package dselect. (Mon, 07 Sep 2009 07:15:17 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Mon, 07 Sep 2009 07:15:17 GMT) Full text and rfc822 format available.

Message #15 received at 545366@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Petr Vandrovec <vandrove@vc.cvut.cz>, 545366@bugs.debian.org, Romain Bossart <romain.bossart@free.fr>
Subject: Re: Bug#545366: dselect 1.15.4 does not distinguish between new and old packages
Date: Mon, 7 Sep 2009 09:11:45 +0200
On Sun, 06 Sep 2009, Petr Vandrovec wrote:
> Since today's update run dselect is completely confused and does not
> remember which packages are new and which are old - it lists all
> available and not installed packages as new, again and again.  And
> not only that, it also marks some of them for installation although
> I do not want them (and some are not installable at all - for some
> reason it wants to install libsasl2 which is not installable
> together with libsasl2-2).  I see that it updates available &
> status, they seem to contain valid data, but on load it somehow
> ignores them.
> 
> Besides that it creates some strange /var/lib/dpkg/updates/tmp.i
> which is full of lines saying '##padding', but other than that I do
> not see what can be wrong, and unfortunately diff between 1.15.3.1
> and 1.15.4 is quite huge.

You can use "git bisect" to isolate the problem more precisely. My bet
would be on the code that auto-cleans up the status database, maybe it
applies by error on the available file as well and thus it believes
that all packages are new everytime?

Cheers,
-- 
Raphaël Hertzog




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#545366; Package dselect. (Mon, 07 Sep 2009 07:51:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sven Joachim <svenjoac@gmx.de>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Mon, 07 Sep 2009 07:51:07 GMT) Full text and rfc822 format available.

Message #20 received at 545366@bugs.debian.org (full text, mbox):

From: Sven Joachim <svenjoac@gmx.de>
To: Raphael Hertzog <hertzog@debian.org>
Cc: 545366@bugs.debian.org, Petr Vandrovec <vandrove@vc.cvut.cz>, Romain Bossart <romain.bossart@free.fr>
Subject: Re: Bug#545366: dselect 1.15.4 does not distinguish between new and old packages
Date: Mon, 07 Sep 2009 09:43:37 +0200
On 2009-09-07 09:11 +0200, Raphael Hertzog wrote:

> On Sun, 06 Sep 2009, Petr Vandrovec wrote:
>> Since today's update run dselect is completely confused and does not
>> remember which packages are new and which are old - it lists all
>> available and not installed packages as new, again and again.  And
>> not only that, it also marks some of them for installation although
>> I do not want them (and some are not installable at all - for some
>> reason it wants to install libsasl2 which is not installable
>> together with libsasl2-2).  I see that it updates available &
>> status, they seem to contain valid data, but on load it somehow
>> ignores them.
>> 
>> Besides that it creates some strange /var/lib/dpkg/updates/tmp.i
>> which is full of lines saying '##padding', but other than that I do
>> not see what can be wrong, and unfortunately diff between 1.15.3.1
>> and 1.15.4 is quite huge.
>
> You can use "git bisect" to isolate the problem more precisely. My bet
> would be on the code that auto-cleans up the status database,

Certainly.  FWIW, the problem occurs also if only dpkg is upgraded to
1.15.4 and dselect stays at 1.15.3.1.

> maybe it applies by error on the available file as well and thus it
> believes that all packages are new everytime?

Given that the available package is as big as ever and dselect shows
every package as new even after you run "sync-available" (from the
dctrl-tools package), this does not seem to be the case.

Sven




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#545366; Package dselect. (Mon, 07 Sep 2009 16:18:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Petr Vandrovec <vandrove@vc.cvut.cz>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Mon, 07 Sep 2009 16:18:05 GMT) Full text and rfc822 format available.

Message #25 received at 545366@bugs.debian.org (full text, mbox):

From: Petr Vandrovec <vandrove@vc.cvut.cz>
To: Raphael Hertzog <hertzog@debian.org>
Cc: 545366@bugs.debian.org, Romain Bossart <romain.bossart@free.fr>
Subject: Re: Bug#545366: dselect 1.15.4 does not distinguish between new and old packages
Date: Mon, 07 Sep 2009 18:13:01 +0200
Raphael Hertzog napsal(a):
> On Sun, 06 Sep 2009, Petr Vandrovec wrote:
> You can use "git bisect" to isolate the problem more precisely. My bet
> would be on the code that auto-cleans up the status database, maybe it
> applies by error on the available file as well and thus it believes
> that all packages are new everytime?

224f0285abc304bec059e61447781... is first bad commit
commit 224f0285...
Author: Guillem Jover <guillem@debian.org>
Date:   Sun Jul 12 20:11:53 2009 +0200

   Obsolete --forget-old-unavail

   On parse mark not-installed leftover packages for automatic removal from
   the database on next dump ...

   Closes: #333394, #429262


And while we are on it, checkin 7fa96f35... (disable default automake 
paths) causes FTBFS on my box.
							Petr






Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#545366; Package dselect. (Tue, 08 Sep 2009 07:45:45 GMT) Full text and rfc822 format available.

Acknowledgement sent to Guillem Jover <guillem@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Tue, 08 Sep 2009 07:45:45 GMT) Full text and rfc822 format available.

Message #30 received at 545366@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: Sven Joachim <svenjoac@gmx.de>, 545366@bugs.debian.org
Cc: Raphael Hertzog <hertzog@debian.org>, Petr Vandrovec <vandrove@vc.cvut.cz>, Romain Bossart <romain.bossart@free.fr>
Subject: Re: Bug#545366: dselect 1.15.4 does not distinguish between new and old packages
Date: Tue, 8 Sep 2009 09:28:06 +0200
Hi!

On Mon, 2009-09-07 at 09:43:37 +0200, Sven Joachim wrote:
> On 2009-09-07 09:11 +0200, Raphael Hertzog wrote:
> > On Sun, 06 Sep 2009, Petr Vandrovec wrote:
> > > Since today's update run dselect is completely confused and does not
> > > remember which packages are new and which are old - it lists all
> > > available and not installed packages as new, again and again. And

Hrmmmf, ok missed that one when doing the automatic forget change on
dpkg...

> > > not only that, it also marks some of them for installation although
> > > I do not want them (and some are not installable at all - for some
> > > reason it wants to install libsasl2 which is not installable
> > > together with libsasl2-2).  I see that it updates available &
> > > status, they seem to contain valid data, but on load it somehow
> > > ignores them.

The installability problems I assume is due to some transition going
on in unstable right now.

> > > Besides that it creates some strange /var/lib/dpkg/updates/tmp.i
> > > which is full of lines saying '##padding', but other than that I do
> > > not see what can be wrong, and unfortunately diff between 1.15.3.1
> > > and 1.15.4 is quite huge.

The “tmp.i” file is normal, yes.

> > You can use "git bisect" to isolate the problem more precisely. My bet
> > would be on the code that auto-cleans up the status database,
> 
> Certainly.  FWIW, the problem occurs also if only dpkg is upgraded to
> 1.15.4 and dselect stays at 1.15.3.1.
> 
> > maybe it applies by error on the available file as well and thus it
> > believes that all packages are new everytime?
> 
> Given that the available package is as big as ever and dselect shows
> every package as new even after you run "sync-available" (from the
> dctrl-tools package), this does not seem to be the case.

The problem is that dselect used the status file to track not seen
and seen not-installed packages as either want_unknown or want_purge
want states. And was setting all want_unknown packages to want_purge
on normal exit (not using X keyibindig).

This increases the status file, the parsing and processing time when
doing dependency resolutions and package iterations for everyone, and
just to be able to show new packages on dselect. The correct solution
here is not to revert the change, but to store the seen/not-seen
information in another place, in a similar way as how apt/aptitude do
it. And ideally in a unified place which all front-ends can share, so
we avoid duplication.

I'll put it on the pending stuff to discuss with the front-end
developers.

regards,
guillem




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#545366; Package dselect. (Tue, 08 Sep 2009 15:48:12 GMT) Full text and rfc822 format available.

Acknowledgement sent to Petr Vandrovec <vandrove@vc.cvut.cz>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Tue, 08 Sep 2009 15:48:14 GMT) Full text and rfc822 format available.

Message #35 received at 545366@bugs.debian.org (full text, mbox):

From: Petr Vandrovec <vandrove@vc.cvut.cz>
To: Guillem Jover <guillem@debian.org>
Cc: Sven Joachim <svenjoac@gmx.de>, 545366@bugs.debian.org, Raphael Hertzog <hertzog@debian.org>, Romain Bossart <romain.bossart@free.fr>
Subject: Re: Bug#545366: dselect 1.15.4 does not distinguish between new and old packages
Date: Tue, 08 Sep 2009 17:33:59 +0200
Guillem Jover napsal(a):
> Hi!
> This increases the status file, the parsing and processing time when
> doing dependency resolutions and package iterations for everyone, and
> just to be able to show new packages on dselect. The correct solution
> here is not to revert the change, but to store the seen/not-seen
> information in another place, in a similar way as how apt/aptitude do
> it. And ideally in a unified place which all front-ends can share, so
> we avoid duplication.

IMHO change should be reverted until old functionality can be achieved 
through some other way - unless you can achieve such functionality today.
						Petr





Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#545366; Package dselect. (Wed, 09 Sep 2009 23:21:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Domenico Andreoli <cavok@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 09 Sep 2009 23:21:03 GMT) Full text and rfc822 format available.

Message #40 received at 545366@bugs.debian.org (full text, mbox):

From: Domenico Andreoli <cavok@debian.org>
To: 545366@bugs.debian.org
Subject: Re: Bug#545366: dselect 1.15.4 does not distinguish between new and old packages
Date: Thu, 10 Sep 2009 01:08:48 +0200
Yes please, revert that commit. dselect is currently unusable.

regards,
Domenico

-----[ Domenico Andreoli, aka cavok
 --[ http://www.dandreoli.com/gpgkey.asc
   ---[ 3A0F 2F80 F79C 678A 8936  4FEE 0677 9033 A20E BC50




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#545366; Package dselect. (Thu, 10 Sep 2009 07:12:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 10 Sep 2009 07:12:06 GMT) Full text and rfc822 format available.

Message #45 received at 545366@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Petr Vandrovec <vandrove@vc.cvut.cz>, 545366@bugs.debian.org
Cc: Sven Joachim <svenjoac@gmx.de>, Romain Bossart <romain.bossart@free.fr>, Domenico Andreoli <cavok@debian.org>
Subject: Re: Bug#545366: dselect 1.15.4 does not distinguish between new and old packages
Date: Thu, 10 Sep 2009 09:03:07 +0200
severity 545366 serious
thanks

On Tue, 08 Sep 2009, Petr Vandrovec wrote:
> IMHO change should be reverted until old functionality can be
> achieved through some other way - unless you can achieve such
> functionality today.

I'd like to remind everybody that we're looking for someone to step up and
maintain dselect:
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=282283

Here's your chance instead of requesting an instant fix from people who
would rather not have to maintain dselect as part of dpkg.

I'll mark this bug as RC so that it doesn't get into testing, you're free
to downgrade dpkg in the mean time.

Cheers,
-- 
Raphaël Hertzog




Severity set to 'serious' from 'normal' Request was from Raphael Hertzog <hertzog@debian.org> to control@bugs.debian.org. (Thu, 10 Sep 2009 07:12:08 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#545366; Package dselect. (Mon, 28 Sep 2009 05:57:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to ctl <ctl@hfds.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Mon, 28 Sep 2009 05:57:10 GMT) Full text and rfc822 format available.

Message #52 received at 545366@bugs.debian.org (full text, mbox):

From: ctl <ctl@hfds.com>
To: 545366@bugs.debian.org
Subject: possible reason why dselect is currently broken in sid and also in testing...
Date: Mon, 28 Sep 2009 00:46:48 -0500
there is no  /var/cache/apt/available

partial output of dselect update ...
Replacing available packages info, using /var/cache/apt/available.

man dselect
dselect --admindir <directory>
Changes  the  directory  where  the  dpkg `status',`available' and 
similar files are located. This defaults to /var/lib/dpkg and normally 
there shouldn't be any  need  to change it.

man dpkg
dpkg --update-avail, --merge-avail Packages-file
Update  dpkg's  and  dselect's  idea  of  which  packages are available. 
With action --merge-avail, old information is combined with information 
from Packages-file.  With action  --update-avail, old information is 
replaced with the information in the Packages-file. The Packages-file 
distributed with Debian is simply named Packages. dpkg keeps its record 
of available packages in /var/lib/dpkg/available.

hth
really
ctl
aka jetscreamer





Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#545366; Package dselect. (Thu, 01 Oct 2009 14:45:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to ctl <ctl@hfds.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 01 Oct 2009 14:45:05 GMT) Full text and rfc822 format available.

Message #57 received at 545366@bugs.debian.org (full text, mbox):

From: ctl <ctl@hfds.com>
To: 545366@bugs.debian.org
Subject: lenny downgrade
Date: Thu, 01 Oct 2009 09:39:24 -0500
even downgrading to the version of dselect in lenny does not fix this 
behavior. therefore (obviously?) this is not a problem in dselect but 
something else? did somebody change dpkg's defaults? beyond me. :(

hope dselect gets fixed soon though. i really don't like aptitude.
nor anything else...

tia
ctl




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#545366; Package dselect. (Fri, 09 Oct 2009 05:21:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to ctl <ctl@hfds.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Fri, 09 Oct 2009 05:21:02 GMT) Full text and rfc822 format available.

Message #62 received at 545366@bugs.debian.org (full text, mbox):

From: ctl <ctl@hfds.com>
To: 545366@bugs.debian.org
Subject: additional observed behavior
Date: Fri, 09 Oct 2009 00:16:34 -0500
don't know if this helps, but when i tried cp'ing available to 
/var/cache/apt, when i do dselect update, /var/cache/apt/available gets 
deleted.

also, cp'ing var/lib/dpkg to /var/cache/apt then setting admindir in the 
command line didn't work, nor setting it in /etc/dpkg/*.conf. still deleted.

setting admindir manually in console and also in the conffiles to the 
default location didn't work either. :(


anyway
ctl




Added tag(s) pending. Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Mon, 19 Oct 2009 16:29:54 GMT) Full text and rfc822 format available.

Bug 545366 cloned as bug 551638. Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Mon, 19 Oct 2009 16:29:56 GMT) Full text and rfc822 format available.

Changed Bug title to 'dselect: track seen packages in a new frontend-unified state file' from 'dselect 1.15.4 does not distinguish between new and old packages' Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Mon, 19 Oct 2009 16:30:01 GMT) Full text and rfc822 format available.

Severity set to 'important' from 'serious' Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Tue, 20 Oct 2009 00:54:07 GMT) Full text and rfc822 format available.

Removed tag(s) pending. Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Tue, 20 Oct 2009 00:54:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#551638; Package dselect. (Tue, 20 Oct 2009 23:57:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sandro Weiser <sandro.weiser@informatik.tu-chemnitz.de>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Tue, 20 Oct 2009 23:57:08 GMT) Full text and rfc822 format available.

Message #77 received at 551638@bugs.debian.org (full text, mbox):

From: Sandro Weiser <sandro.weiser@informatik.tu-chemnitz.de>
To: 551638@bugs.debian.org
Subject: 1.15.4.1 still broken
Date: Wed, 21 Oct 2009 01:46:15 +0200
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA512

Today I installed dpkg, dpkg-dev and dselect 1.15.4.1.
I hoped that the error is fixed, but he is still there.
I use _only_ dselect, because I love it!
Can you please fix it?

Sandro

- --
Sandro Weiser <Sandro.Weiser@gmx.de>
Fingerprint: 77E0 7C87 4DB2 6BBB 5419  343C 7995 1C67 25B9 CBF1
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEAREKAAYFAkreS8cACgkQeZUcZyW5y/Fx0gCgwWVil1PxhG0D0fyjvT0FTzJA
D7UAn0GLlVvk/54yGLVLQTzLxaliUJns
=LLAf
-----END PGP SIGNATURE-----




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#551638; Package dselect. (Wed, 21 Oct 2009 06:24:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 21 Oct 2009 06:24:03 GMT) Full text and rfc822 format available.

Message #82 received at 551638@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Sandro Weiser <sandro.weiser@informatik.tu-chemnitz.de>, 551638@bugs.debian.org
Subject: Re: Bug#551638: 1.15.4.1 still broken
Date: Wed, 21 Oct 2009 08:11:54 +0200
On Wed, 21 Oct 2009, Sandro Weiser wrote:
> Today I installed dpkg, dpkg-dev and dselect 1.15.4.1.
> I hoped that the error is fixed, but he is still there.
> I use _only_ dselect, because I love it!
> Can you please fix it?

What is precisely the error that you're seeing?

Cheers,
-- 
Raphaël Hertzog




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#551638; Package dselect. (Wed, 21 Oct 2009 12:15:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sandro Weiser <sandro.weiser@informatik.tu-chemnitz.de>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 21 Oct 2009 12:15:07 GMT) Full text and rfc822 format available.

Message #87 received at 551638@bugs.debian.org (full text, mbox):

From: Sandro Weiser <sandro.weiser@informatik.tu-chemnitz.de>
To: Raphael Hertzog <hertzog@debian.org>, 551638@bugs.debian.org
Subject: Re: Bug#551638: 1.15.4.1 still broken
Date: Wed, 21 Oct 2009 13:35:50 +0200
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA512

Raphael Hertzog schrieb:
> What is precisely the error that you're seeing?
The "original" error:
Since today's update run dselect is completely confused and does not
remember which packages are new and which are old - it lists all
available and not installed packages as new, again and again.  And not
only that, it also marks some of them for installation although I do not
want them (and some are not installable at all - for some reason it
wants to install libsasl2 which is not installable together with
libsasl2-2).  I see that it updates available & status, they seem to
contain valid data, but on load it somehow ignores them.

Sandro

- --
Sandro Weiser <Sandro.Weiser@gmx.de>
Fingerprint: 77E0 7C87 4DB2 6BBB 5419  343C 7995 1C67 25B9 CBF1
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEAREKAAYFAkre8hYACgkQeZUcZyW5y/Fu9ACgqEjAkiZcmS0N0LZvRXxWeGT7
5vgAoNDXfFBddtmdbRr7Fv1i1/y9Mqni
=hlLS
-----END PGP SIGNATURE-----




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#551638; Package dselect. (Sun, 25 Oct 2009 11:00:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sun, 25 Oct 2009 11:00:05 GMT) Full text and rfc822 format available.

Message #92 received at 551638@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Piotr Engelking <inkerman42@gmail.com>, 545366-done@bugs.debian.org
Cc: 551638@bugs.debian.org
Subject: Re: Bug#545366: dselect 1.15.4 does not distinguish between new and old packages
Date: Sun, 25 Oct 2009 11:40:41 +0100
Version: 1.15.4.1

On Sun, 25 Oct 2009, Piotr Engelking wrote:
> The only difference between 1.15.4 and 1.15.4.1 is that former marks
> new and old packages as new, and the latter marks new and old packages
> as old.

That's what we wanted. Closing this bug again. The fact that it doesn't
keep track of new packages is tracked in #551638 and is not release
critical for us.

Please use the other bug for further discussion.

Cheers,
-- 
Raphaël Hertzog




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#551638; Package dselect. (Sun, 25 Oct 2009 15:00:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Piotr Engelking <inkerman42@gmail.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sun, 25 Oct 2009 15:00:05 GMT) Full text and rfc822 format available.

Message #97 received at 551638@bugs.debian.org (full text, mbox):

From: Piotr Engelking <inkerman42@gmail.com>
To: 551638@bugs.debian.org
Subject: Re: Bug#545366: dselect 1.15.4 does not distinguish between new and old packages
Date: Sun, 25 Oct 2009 15:45:16 +0100
Raphael Hertzog <hertzog@debian.org>:

>> The only difference between 1.15.4 and 1.15.4.1 is that former marks
>> new and old packages as new, and the latter marks new and old packages
>> as old.
>
> That's what we wanted. Closing this bug again. The fact that it doesn't
> keep track of new packages is tracked in #551638 and is not release
> critical for us.

While the change was, indeed, intended, it doesn't change the fact
that it does nothing to fix the problem.




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#551638; Package dselect. (Tue, 08 Dec 2009 18:30:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to ctl <ctl@hfds.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Tue, 08 Dec 2009 18:30:03 GMT) Full text and rfc822 format available.

Message #102 received at 551638@bugs.debian.org (full text, mbox):

From: ctl <ctl@hfds.com>
To: 551638@bugs.debian.org
Subject: refuse
Date: Tue, 08 Dec 2009 12:21:03 -0600
your fix changed nothing, everything is still marked new. you were wrong.
downgrading to the lenny version changed nothing, it doesn't work 
either. once again, you are wrong.

you broke it yet refuse to fix it. this seems to be becoming typical.
i suggest you take dselect out if you continue in this vein.
oh... it's tied too closely to dpkg you say. we can't fix it.
so you will continue to release buggy non-functional stable releases of 
this distro.

re Disk devices may change on reboot, as seen on 
http://www.debian.org/releases/stable/debian-installer/...
i found this bug back when the sid kernel was 2.6.13 or so, yet it's 
still not fixed. afaict, it won't be. yet this is truly a show stopper.
i have no idea what the bug number is, nor do i care anymore.

i find it TRULY a shame that i've wasted so many years on debian now.
all it is, basically, is ubuntu. if i wanted to run ubuntu, i would.

thank you for your support




Added tag(s) patch. Request was from Robert Luberda <robert@debian.org> to control@bugs.debian.org. (Sun, 21 Mar 2010 00:36:06 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#551638; Package dselect. (Sun, 21 Mar 2010 00:45:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Robert Luberda <robert@pingu.ii.uj.edu.pl>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sun, 21 Mar 2010 00:45:06 GMT) Full text and rfc822 format available.

Message #109 received at 551638@bugs.debian.org (full text, mbox):

From: Robert Luberda <robert@pingu.ii.uj.edu.pl>
To: 559519@bugs.debian.org
Cc: 551638@bugs.debian.org
Subject: Re: Tracking seen packages in dselect - patch
Date: Sun, 21 Mar 2010 01:43:42 +0100
> 
> Please note that although the patch was intended for the bug 559519, it
> also fixes bug 556889 as dselect always select unseen required or
> important packages for installation.
> 

I meant bug 551638 instead of 559519.

Regards,
robert




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#551638; Package dselect. (Sat, 27 Mar 2010 10:06:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Robert Luberda <robert@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sat, 27 Mar 2010 10:06:09 GMT) Full text and rfc822 format available.

Message #114 received at 551638@bugs.debian.org (full text, mbox):

From: Robert Luberda <robert@debian.org>
To: 551638@bugs.debian.org
Cc: 556889@bugs.debian.org
Subject: Updated patch for dselect bugs
Date: Sat, 27 Mar 2010 10:58:28 +0100
[Message part 1 (text/plain, inline)]
Hi,

I discovered that the previous version of my patch re-added the "purge
ok not-installed" packages into status file. Fortunately the issue
turned out to be quite simple to fix. I'm attaching a new patch split
into two files.

The first one, 1_dselect_559519+556889.patch.gz, causes dselect to treat
all unknown packages all as already seen. This fixes #556889, since
dselect never automatically selects already seen packages for installation.
The change is especially visible at the packages' selection screen: the
non-patched version shows status `n_' (meaning `new purge') for most
packages, for example:
  n_ Xtr x11      choosewm     <none>      0.1.6-1     fake ...
  n_ Xtr x11      compiz-fusio <none>      0.8.4-1     Compiz Fusion ...
  n_ Xtr x11      compiz-fusio <none>      0.8.4-2     Compiz Fusion ...
My version displays the status as '__' (`purge purge').
I hope the patch would be quite safe for applying in dselect.


With the second patch, 2_dselect_551638.patch.gz, dselect stores already
seen packages in packages-seen file - one package name in each line. It
would be nice if you could apply this patch too, even though you might
dislike it e.g. because db is certainly not `fronted united', coding
introduces usage of STL maps, strings and iostreams and doesn't look
like the awful `C with classes' used elsewhere in dselect codes.

Regards,
robert



[1_dselect_559519+556889.patch.gz (application/gzip, inline)]
[2_dselect_551638.patch.gz (application/gzip, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#551638; Package dselect. (Mon, 29 Mar 2010 08:57:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Mon, 29 Mar 2010 08:57:03 GMT) Full text and rfc822 format available.

Message #119 received at 551638@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Robert Luberda <robert@debian.org>, 551638@bugs.debian.org
Cc: 556889@bugs.debian.org
Subject: Re: Bug#551638: Updated patch for dselect bugs
Date: Mon, 29 Mar 2010 10:51:47 +0200
On Sat, 27 Mar 2010, Robert Luberda wrote:
> I discovered that the previous version of my patch re-added the "purge
> ok not-installed" packages into status file. Fortunately the issue
> turned out to be quite simple to fix. I'm attaching a new patch split
> into two files.
> 
> The first one, 1_dselect_559519+556889.patch.gz, causes dselect to treat
> all unknown packages all as already seen. This fixes #556889, since
> dselect never automatically selects already seen packages for installation.
> The change is especially visible at the packages' selection screen: the
> non-patched version shows status `n_' (meaning `new purge') for most
> packages, for example:
>   n_ Xtr x11      choosewm     <none>      0.1.6-1     fake ...
>   n_ Xtr x11      compiz-fusio <none>      0.8.4-1     Compiz Fusion ...
>   n_ Xtr x11      compiz-fusio <none>      0.8.4-2     Compiz Fusion ...
> My version displays the status as '__' (`purge purge').
> I hope the patch would be quite safe for applying in dselect.
> 
> 
> With the second patch, 2_dselect_551638.patch.gz, dselect stores already
> seen packages in packages-seen file - one package name in each line. It
> would be nice if you could apply this patch too, even though you might
> dislike it e.g. because db is certainly not `fronted united', coding
> introduces usage of STL maps, strings and iostreams and doesn't look
> like the awful `C with classes' used elsewhere in dselect codes.

How can the two patches work together? I mean either the package has been
already seen or it's not.

A new package by definition has no entry in the status file so it's
unknown (and thus seen) according to the first patch. What good does the
second patch do then?

Otherwise I discussed your patch with Guillem quickly the other day and he
would like to store the seen/not-seen information in a common place (i.e.
shared by all frontends). I'm not sure there's enough time to implement
this in the squeeze timeframe. Guillem mentionnend reverting part of the
problematic changes if he can't manage this in time, I'm not sure I like
this, I would rather commit something based on your patch.

In that case, if we store the data in a frontend-specific manner, the file
shall be stored in /var/lib/dselect and not /var/lib/dpkg. Our goal is to
prepare a split so new files should go there IMO.

In the mean time, I think committing your first patch would alleviate the
most annoying side-effects of the current situation. I would be in favor
of that, Guillem what do you think?

Cheers,
-- 
Raphaël Hertzog

Like what I do? Sponsor me: http://ouaza.com/wp/2010/01/05/5-years-of-freexian/
My Debian goals: http://ouaza.com/wp/2010/01/09/debian-related-goals-for-2010/




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#551638; Package dselect. (Tue, 30 Mar 2010 12:36:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Robert Luberda <robert@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Tue, 30 Mar 2010 12:36:07 GMT) Full text and rfc822 format available.

Message #124 received at 551638@bugs.debian.org (full text, mbox):

From: Robert Luberda <robert@debian.org>
To: Raphael Hertzog <hertzog@debian.org>
Cc: 551638@bugs.debian.org, 556889@bugs.debian.org
Subject: Re: Bug#551638: Updated patch for dselect bugs
Date: Tue, 30 Mar 2010 14:09:17 +0200
Raphael Hertzog writes:
> 
> How can the two patches work together? I mean either the package has been
> already seen or it's not.

The second patch complements to the first one, i.e. the latter depends
on and extends the former one.

Currently dselect treats all unknown packages as unseen, which is
clearly visible by users and causes the behaviour reported in #556889.

> 
> A new package by definition has no entry in the status file so it's
> unknown (and thus seen) according to the first patch. What good does the
> second patch do then?

In short the first patch makes dselect to treat all unknown packages as
already seen, whereas the second one adds to it ability to distinguish
between seen and unseen packages (so with the second patch unknown
packages are no longer all seen by default).

As you can see, the second patch contains amongst others the following
change:
-    state->direct= state->original= (pkg->want == pkginfo::want_unknown
 ? pkginfo::want_purge : pkg->want);
+    state->direct= state->original= (pkg->want == pkginfo::want_unknown
 && seen ? pkginfo::want_purge : pkg->want);
 ^^^^^^^

> 
> Otherwise I discussed your patch with Guillem quickly the other day and he
> would like to store the seen/not-seen information in a common place (i.e.
> shared by all frontends).  I'm not sure there's enough time to implement
> this in the squeeze timeframe.  Guillem mentionnend reverting part of the
> problematic changes if he can't manage this in time, I'm not sure I like
> this, I would rather commit something based on your patch.


I was aware of Guillem's intentions, after all he put the magic
`frontend-unified state file' phrase in the bug's #551638 description :)
I think it's a nice idea, but probably not for squeeze. Even if you
manage to add such a file into dpkg on time for squeeze, most probably
aptitude, synaptic and any other frontend (besides dselect) won't
switch to using it so fast. So how about implementing temporary
dselect-only solution for now and implementing the proper solution for
squeeze + 1?


> 
> In that case, if we store the data in a frontend-specific manner, the file
> shall be stored in /var/lib/dselect and not /var/lib/dpkg. Our goal is to
> prepare a split so new files should go there IMO.

That's OK. I've put it in $admindir for simplicity and not to care about
locking the file as the any reads/writes are done where dpkg's status
database in locked. If you put the file somewhere else probably:
- either you would need to add some locking
- or the file location would need to depend on $admindir (like
$admindir/../dselect/, but it's quite strange)
- eventually you would need to drop the --admindir option from dselect
(honestly I've never used it).

> 
> In the mean time, I think committing your first patch would alleviate the
> most annoying side-effects of the current situation. 

I second this.

> I would be in favor
> of that, Guillem what do you think?

Regards,
robert
> 
> Cheers,






Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#551638; Package dselect. (Wed, 14 Apr 2010 19:42:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Filip Van Raemdonck <mechanix@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 14 Apr 2010 19:42:03 GMT) Full text and rfc822 format available.

Message #129 received at 551638@bugs.debian.org (full text, mbox):

From: Filip Van Raemdonck <mechanix@debian.org>
To: Raphael Hertzog <hertzog@debian.org>
Cc: 551638@bugs.debian.org, Robert Luberda <robert@debian.org>, 556889@bugs.debian.org
Subject: Re: Bug#551638: Updated patch for dselect bugs
Date: Wed, 14 Apr 2010 21:35:06 +0200
On Tue, Mar 30, 2010 at 02:09:17PM +0200, Robert Luberda wrote:
> Raphael Hertzog writes:
> > 
> > Otherwise I discussed your patch with Guillem quickly the other day and he
> > would like to store the seen/not-seen information in a common place (i.e.
> > shared by all frontends).  I'm not sure there's enough time to implement
> > this in the squeeze timeframe.  Guillem mentionnend reverting part of the
> > problematic changes if he can't manage this in time, I'm not sure I like
> > this, I would rather commit something based on your patch.
> 
> I was aware of Guillem's intentions, after all he put the magic
> `frontend-unified state file' phrase in the bug's #551638 description :)
> I think it's a nice idea, but probably not for squeeze. Even if you
> manage to add such a file into dpkg on time for squeeze, most probably
> aptitude, synaptic and any other frontend (besides dselect) won't
> switch to using it so fast. So how about implementing temporary
> dselect-only solution for now and implementing the proper solution for
> squeeze + 1?

I'd like to vote for getting back the old functionality, where one could
easily see which new software was available in the archives.
If that means Robert's two patches, with a temporary solution and other
frontends following suite after squeeze, by all means make it so.

This is dselect functionality from back when apt did not exist and there
were no other package management frontends in Debian.
Don't leave it broken in a stable release.


KR, Filip

-- 
http://blog.sysfs.net/




Removed tag(s) patch. Request was from Raphaël Hertzog <hertzog@debian.org> to control@bugs.debian.org. (Thu, 06 May 2010 13:33:09 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 11:05:08 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.